#include <bits/stdc++.h> // score: 100
using namespace std;

int main() {
#define int int_least64_t
  cin.tie(0);
  ios::sync_with_stdio(false);
  int r, c; cin >> r >> c;
  vector<int> a(r*c); copy_n(istream_iterator<int>(cin), a.size(), a.begin());
  vector<int> b(r*c); copy_n(istream_iterator<int>(cin), b.size(), b.begin());

  vector<int> indices(r*c);
  iota(indices.begin(), indices.end(), 0);
  sort(indices.begin(), indices.end(), [&a](int i, int j) { return a[i] < a[j]; });

  array<int, 4> best{}, new_best{};
  fill(new_best.begin(), new_best.end(), -r-c);
  int last_attr = -1, solution=0;
  for (int i : indices) {
    if (!a[i])
      continue;
    if (a[i] != last_attr)
      tie(best, last_attr) = make_pair(new_best, a[i]);
    const int x=i%c, y=i/c;
    auto level = [&](int d) { return (d&1?c-1-x:x) + (d&2?r-1-y:y); };
    int gain = 0;
    for (int d=0; d<4; ++d)
      gain = max(gain, b[i] + max(int(0), best[d] + level(d)));
    for (int d=0; d<4; ++d)
      new_best[d] = max(new_best[d], gain - level(d));
    solution = max(solution, gain);
  }
  cout << solution << '\n';
}
